=== debian/changelog ===
nextpnr (0.9-1) unstable; urgency=medium

  * New upstream version 0.9
  * Bump to Standards-Version 4.7.2
  * d/control: Update uploaders {dxld,sjr}@d.o
  * Add NEWS entry for gowin -> himbaechel-gowin change
  * Add patch to use Debian googletest
  * d/control: Add B-D on pybind11-dev

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 01 Mar 2026 21:11:04 +0100
