=== debian/watch ===
# Note: gitmodules needs
#   https://salsa.debian.org/debian/devscripts/-/merge_requests/480
# Should land in uscan/forky

version=4
opts=\
mode=git,\
gitmodules=all,\
compression=gz \
https://github.com/YosysHQ/nextpnr.git refs/tags/nextpnr-@ANY_VERSION@
